using System;
using System.Drawing;
using System.Drawing.Text;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.pictureBox.Resize += pictureBox_Resize;
            this.pictureBox.Paint  += pictureBox_Paint;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region ó ڽ Ʈ óϱ - pictureBox_Paint(sender, e)

        /// <summary>
        /// ó ڽ Ʈ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pictureBox_Paint(object sender, PaintEventArgs e)
        {
            using(Font font = new Font("ڵ", 40, FontStyle.Bold))
            {
                DrawSplitText
                (
                    e.Graphics,
                    "밢  ؽƮ",
                    font,
                    this.pictureBox.ClientRectangle,
                    Brushes.Black,
                    Brushes.White
                );
            }
        }

        #endregion
        #region ó ڽ ũ  óϱ - pictureBox_Resize(sender, e)

        /// <summary>
        /// ó ڽ ũ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pictureBox_Resize(object sender, EventArgs e)
        {
            this.pictureBox.Refresh();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region и ؽƮ ׸ - DrawSplitText(graphics, text, font, rectangle, topForegroundBrush, bottomForegroundBrush)

        /// <summary>
        /// и ؽƮ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="text">ؽƮ</param>
        /// <param name="font">Ʈ</param>
        /// <param name="rectangle">簢</param>
        /// <param name="topForegroundBrush">  귯</param>
        /// <param name="bottomForegroundBrush">ϴ  귯</param>
        private void DrawSplitText
        (
            Graphics  graphics,
            string    text,
            Font      font,
            Rectangle rectangle,
            Brush     topForegroundBrush,
            Brush     bottomForegroundBrush
        )
        {
            Bitmap topBitmap    = new Bitmap(rectangle.Width, rectangle.Height);
            Bitmap bottomBitmap = new Bitmap(rectangle.Width, rectangle.Height);

            using(StringFormat stringFormat = new StringFormat())
            {
                stringFormat.Alignment     = StringAlignment.Center;
                stringFormat.LineAlignment = StringAlignment.Center;

                using(Graphics topGraphics = Graphics.FromImage(topBitmap))
                {
                    topGraphics.TextRenderingHint = TextRenderingHint.AntiAliasGridFit;

                    topGraphics.FillRectangle(bottomForegroundBrush, rectangle);

                    topGraphics.DrawString(text, font, topForegroundBrush, rectangle, stringFormat);
                }

                using(Graphics bottomGraphics = Graphics.FromImage(bottomBitmap))
                {
                    bottomGraphics.TextRenderingHint = TextRenderingHint.AntiAliasGridFit;

                    bottomGraphics.FillRectangle(topForegroundBrush, rectangle);

                    bottomGraphics.DrawString(text, font, bottomForegroundBrush, rectangle, stringFormat);
                }
            }

            using(TextureBrush brush = new TextureBrush(topBitmap))
            {
                graphics.FillRectangle(brush, rectangle);
            }

            Point[] pointArray = 
            {
                new Point(rectangle.X    , rectangle.Y     ),
                new Point(rectangle.X    , rectangle.Bottom),
                new Point(rectangle.Right, rectangle.Bottom)
            };

            using(TextureBrush brush = new TextureBrush(bottomBitmap))
            {
                graphics.FillPolygon(brush, pointArray);
            }

            topBitmap.Dispose();

            bottomBitmap.Dispose();
        }

        #endregion
    }
}